import java.util.Scanner;
import java.util.InputMismatchException;

/**
 * A class whose methods implement a recursive solution to the Fibonacci Series.
 *
 * @author Carl B. Struck
 * @version SCCC West - Copyright (c) 2012
 */
public class Fibonacci
{
    /**
     * Gets an integer from the console, passes it to method fibonacci() and
     * displays the resulting Fibonacci series value to the terminal window.
     *
     * @param args the String[] array command line parameter
     * @throws InputMismatchException if user enters non-integer input
     */
    public static void main(String[] args) throws InputMismatchException
    {
        try
        {
            Scanner input = new Scanner(System.in);

            System.out.print("How many Fibonacci Series value?: ");
            int n = input.nextInt();

            for (int ctr = 0; ctr <= n; ctr++)
            {
                System.out.printf("Fibonacci of %d = %,d%n", ctr, fibonacci(ctr) );
            }
        }

        catch (InputMismatchException ex)
        {
            System.out.println("Input is not an integer");
        }

        catch (Exception ex)
        {
            System.out.println(ex);
        }
    }

    /**
     * A recursive method which calculates and returns a value in the Fibonacci series for
     * a positive integer or zero (0).
     *
     * @param n an int whose Fibonacci Series value is to be calculated
     * @return the Fibonacci Series value of the input integer
     * @throws Exception if user enters negative number
     * @throws Exception if the parameter is greater than 40
     */
    private static int fibonacci(int n) throws Exception
    {
        if (n < 0)
        {
            throw new Exception(
                String.format("Fibonacci Series for %d not possible for negative numbers", n ) );
        }           

        if (n > 40)
        {
            throw new Exception("Value greater than 45 is invalid");
        }

        if (n == 0 || n == 1)
        {
            return n;
        }
        else
        {
            return fibonacci(n - 1) + fibonacci(n - 2);
        }
    }
}

